$MIDDLE$$FONT5$^bChapter: $TOC1$Introduction$TOC1$^b$FONT1$

$CONDFF20$

$FONT5$^bSection: $TOC2$Getting Started$TOC2$^b$FONT1$


$FOOTE$Introduction|#|Welcome$ENDFOOT$$FOOTO$Welcome|#|Getting Started$ENDFOOT$
$BOX$$FONT2$$TOC3$Welcome$TOC3$$FONT1$

Thank you for trying Treeducer, the Laser Printer utility that helps you 
save a tree by greatly reducing the amount of paper needed to print out 
many reports.

I print a lot of simple 80 column and 132 column reports such as Invoice 
Summary listings, Customer Master lists, etc.  I wanted to print these 
double sided with two pages across in landscape mode.  I have an HP 
LaserJet IID, so I also wanted to print double sided as well.

In addition to running SCT Associates, Inc., I am the accountant for Taylor 
Spring, a small manufacturing business owned by my dad and his 4 kids.   
Taylor Spring has been using an Order Entry System and Accounts receivable 
system I designed and co-wrote in Clipper back in 1988.  Basically a 
computerized version of the manual system it replaced, there were lots of 
copies of each form generated such as the Sales Order and the Invoice.  
Now, we've made those forms easier to create, and to reprint them with 
revisions.  Also we now have reports galore to sort open orders, invoices, 
accounts receivable ageings, etc.

The computer system was supposed to reduce the amount of paper in our 
office and in my clients' offices, but it seemed to actually create more 
paper because it was so easy to do.  I started building a very large 
collection of three ring binders to store printouts and copies of forms and 
reports printed on the laser printer.

It was time to wage WAR!  Most of the copies of forms that we printed for 
in-house were getting filed (eventually) and never looked at again.  We 
tried to cut down those extra copies of forms and replace them with a 
report that would take less space.  The report would be a backup in case of 
the system being down.  Even the report versions were taking up too much 
space.  Something needed to be done.

What do you do?  Well necessity is the mother of invention.  Just show a 
client something they'll want and let them pay you to write it for them.  
Well sort of.  I'd used a seperate utility program that let me print source 
code two pages across in landscape mode and double sided.  I liked it so 
much I printed some of my accounting reports to a file so that I could 
print them in this condensed format.  When I showed a new client some 
sample reports that I had printed in that format, they went out and bought 
a LaserJet IIID.  Well I was under the gun to provide some support for this 
printer they bought, so Treeducer was borne out of the need to get a 
user-friendly, and more importantly  a developer-friendly way to cut down 
the amount of paper generated into my new application.

I thought about just using the RUN command to shell out to Dos and run an 
external utility, but then I'd have to get each user licensed for that 
utility.  I'd probably need several copies since most of my clients run on 
LANs.  The needed solution was a function that could be linked into my 
custom applications at no additional per-user charge.  I decided to write 
the function and market it since I was not able to find such a product 
available. 

The Treeducer Library for Clipper was borne out of that effort.  It is 
written in 100% Clipper code to ensure total overlaying compatibility. 
Treeducer Booklet for DOS version 1.0 was written to provide a DOS command 
line version, as well as a way to print out documentation in a 2-up format 
that can be folded and stapled into a booklet complete with a table of 
contents.

We've since then polished and ported this technology to the C language and 
using the Library Construction Kit created a Foxpro library to bring thus 
capability to all Fox developers.  The core C code for the library is both 
faster and smaller than the Clipper counterpart, and since it is the second 
generation, it also has more flexibility designed into it based on some 
lessons learned with the Clipper product.  The same core C library was used 
to create a Force compatible library as well as the Treeducer Booklet 2.0 
version.

Some features that are in the Force and Foxpro versions that are not yet in 
the Clipper Library include:
	- support for setting the number of lines per page 

	- support for multiple pages vertically as well as horizontally
	
	- support for portrait mode printing
	
	- support for %completion and other new status information
	
	- support for limiting printout to a certain page range
	
We'd like to thank you for your support of Treeducer and hope that you'll 
provide this great paper-saving option to all your users.  	

$CONDFF10$$FOOTE$Introduction|#|Installation$ENDFOOT$$FOOTO$Installation|#|Getting Started$ENDFOOT$
$BOX$$FONT2$$TOC3$Installation$TOC3$$FONT1$

To install the software, follow these steps:

The file TDFOX.EXE on the diskette is a self-installing program.  It will 
prompt you for the directory where you want Treeducer for Foxpro installed. 
 It will offer the current directory as a default.  If you type in a 
directory, and it doesn't exist, it will offer to create it for you.

If you are not sure of what I just described, I recommend just creating the 
directory where you want to install it first, then make that the current 
directory.  For example, with the diskette in the A: drive, and suppose you 
want to install the library to the C:\FTD directory, you'd issue these 
commands:

From DOS:
     c:
     md \ftd
     cd \ftd
     a:tdfox

From Windows Program Manager, select File/Run, then enter:
     a:tdfox

  at the prompt for a destination directory, type:
     c:\ftd



$CONDFF10$$CONDFF20$

$FONT5$^bSection: $TOC2$Overview$TOC2$^b$FONT1$


$FOOTE$Introduction|#|Getting Started$ENDFOOT$$FOOTO$Getting Started|#|Overview$ENDFOOT$
$BOX$$FONT2$$TOC3$Getting Started$TOC3$$FONT1$

The Treeduce function is used to print out a plain report to a laser 
printer in 80 column by 66 line format, two pages across in landscape mode, 
or 1 page across in 165 column by 66 line format. The built-in mini 
softfont, and the ability to print as many columns as space will permit 
offers even greater choice in how to present the final printed page.

The function is called in two steps.  First you select all the Treeducer 
options, then you call the Send_TD() function with the name of the file 
that you want to print.

To use Treeducer, you should first create your report to a file. This 
seemed to be the easiest way to integrate the function into existing 
systems.   In-house, we use a standard reporting mechanism that allows the 
user to print to screen. printer or file.  Our screen output is simply a 
report sent to file which we then display using the Fox memo editor.

We have included sample code in the TREESET.PRG to illustrate how you might 
prompt the user for the Treeducer options.  Remember, Treeducer is not 
designed to REPLACE the way you print reports now, it is simply an 
additional option for the user to select at run-time.  As long as you can 
get the report out as a plain ASCII text report, the user can control how 
they want it printed.
    
    


$CONDFF10$$FOOTE$Introduction|#|Double Sided Printing$ENDFOOT$$FOOTO$Double Sided Printing|#|Overview$ENDFOOT$
$BOX$$FONT2$$TOC3$Double Sided Printing$TOC3$$FONT1$

To print double sided with a regular laser printer, you should open the 
face-up paper exit tray (usually in the back), and then print the front 
pages.  You can do this with the FRONTS ONLY option via the TD_Duplex() 
parameter.

After the paper has all printed, reload it into the paper tray face down, 
then print the back sides with the BACKS ONLY option via the TD_Duplex() 
parameter. It may take a couple tries to get the paper handling right if 
you've never done manual two-sided printing before, so practice with a 
small file first.

I've become so hooked on double-sided printing, that I bought a Laserjet 
IID last year, and I talked a client into a IIID after they saw how much 
filespace I'd save them with the convenience of Treeducer built into their 
application.  Another nice thing about the duplex printers is that they 
have two full size paper trays.  I like to use the lower tray for 
letterhead, and in my applications, I create my own special forms for 
invoices, statements, etc.  

As a shared printer on the network, my program can then easily use the top 
tray for reports and automatically print them double sided with Treeducer, 
and the user doesn't have to load special forms, because I print them from 
scratch, on demand.


$CONDFF10$$CONDFF20$

$FONT5$^bSection: $TOC2$Legal Stuff$TOC2$^b$FONT1$


$FOOTE$Introduction|#|Copyright 1993 SCT Associates$ENDFOOT$$FOOTO$Copyright 1993 SCT Associates|#|Legal Stuff$ENDFOOT$
$BOX$$FONT2$$TOC3$Copyright 1993 SCT Associates$TOC3$$FONT1$

This software and documentation is Copyright 1993, 1994 by SCT Associates, 
Inc.

This software program and all the accompanying materials are protected by 
the copyright laws of the United States of America and international treaty 
provisions.  This software is licensed on a "per developer" basis.  This 
means that a seperate license is required for each developer who writes 
software routines which utilize this SOFTWARE, or who links this software 
into an executable form.

Registered users are licensed to distribute the library with their 
application only in executable form as an APP or EXE. 


SCT Associates, Inc.					800-949-6945
9221 S. Kilpatrick Ave.				708-425-0205
Oak Lawn, IL 60453			FAX	708-422-3877


Compuserve: Steve Tyrakowski 73766,1224

$CONDFF10$$FOOTE$Introduction|#|License Terms$ENDFOOT$$FOOTO$License Terms|#|Legal Stuff$ENDFOOT$
$BOX$$FONT2$$TOC3$License Terms$TOC3$$FONT1$

DEMONSTRATION LIBRARY
The demonstration version of this library may be used free of charge for 
purposes of testing the suitability of the software for your needs.  After 
a reasonable period of evaluation, you must purchase a license to continue 
to use the product.

If the demonstration version of the library is required to be linked into 
your system because it was provided by another third party library, you may 
continue to link it in.  In such a case, you may use only the Treeducer 
features provided by the other library, you may not directly access the 
Treeducer library with your own code.

The Trial Version of the Library is limited to 6 pages of output, and it 
prints an advertisement line at the top of each page.  Otherwise it 
contains all the features of the full version.

REGISTERED LIBRARY
SCT Associates, Inc. grants registered users of the SOFTWARE the right to 
incorporate the functions contained in the library into their programs in 
executable form only (i.e. in EXE or APP format).  These functions may not 
be distributed in "linkable" format, or as part of another library.

If you want to distribute the library in a linkable format, you may 
distribute the limited demonstration version with your product.  You are 
encouraged to add Treeducer support to your libraries in this way.  Please 
contact SCT Associates if you plan to do this, so that we may ensure that 
you have the latest version of Treeducer, and so that we may inform our 
customers of "Treeducer-Friendly" libraries.

SAMPLE PROGRAMS
Sample programs have been provided in source code form by SCT Associates, 
Inc. as demonstration examples of how to use the library functions and are 
intended for educational purposes only.  Licensed, registered owners are 
granted the right to modify and incorporate these sample routines INTO 
THEIR OWN PROGRAMS.  You shall remain solely responsible for and will hold 
SCT Associates, Inc. harmless from, all claims, liability and damages 
arising from your own products which include any of the SCT Associates, 
Inc. routines.

For example, you MAY NOT take the sample program with virtually no 
modification, link it with the registered version of the library, and 
distribute it to other users for free or for a fee.  You may link it with 
the demo version of the library and distribute that EXE freely.  

As long as you've added more than a trivial change to the sample code, you 
may distribute it.  



$CONDFF10$$CONDFF20$

$FONT5$^bSection: $TOC2$Libraries$TOC2$^b$FONT1$


$FOOTE$Introduction|#|FOXTDC.PLB$ENDFOOT$$FOOTO$FOXTDC.PLB|#|Libraries$ENDFOOT$
$BOX$$FONT2$$TOC3$FOXTDC.PLB    Foxpro Dos version$TOC3$$FONT1$

The Foxpro Dos version of the library is contained in the FOXTDC.PLB file.  
This file may be freely distributed with your apps.  You may include it as 
part of an APP or EXE file, or you may distribute it as a separate PLB 
file.

It will act as either a registered or a trial version depending upon the 
existence of the TDCLOCK.FXP.

$CONDFF10$$FOOTE$Introduction|#|FOXTDC.FLL$ENDFOOT$$FOOTO$FOXTDC.FLL|#|Libraries$ENDFOOT$
$BOX$$FONT2$$TOC3$FOXTDC.FLL    Foxpro Windows version$TOC3$$FONT1$

The Windows version of the Foxpro Treeducer Library is included in the file 
FOXTDC.FLL.  This file may be distributed freely with your application as 
part of the APP or EXE file.  It may also be included separately as an FLL 
file.

This library will act as either a registered copy, or as demo version 
depending on the existence of the TDCLOCK.FXP module.

$CONDFF10$$FOOTE$Introduction|#|TDCLOCK.FXP$ENDFOOT$$FOOTO$TDCLOCK.FXP|#|Libraries$ENDFOOT$
$BOX$$FONT2$$TOC3$TDCLOCK.FXP   Serialized Unlocker$TOC3$$FONT1$

The TDCLOCK.FXP is a foxpro compiled program that is embedded with your 
registered serial number to activate the live version of the software.  
This may ONLY be distributed as part of an EXE or an APP file.  It may not 
be distributed as a separate file.

If you distribute your applications in source format, you may distribute 
the FOXTDC.PLB and FOXTDC.FLL files so that your user may create a running 
application, but you may not provide the TDCLOCK.FXP as a separate file.  
They will need to obtain their own license to DEVELOP an application using 
Treeducer.  They do not need their own license simply to run a complete 
application you provide.

$CONDFF10$$FOOTE$Introduction|#|Sample PRGs.$ENDFOOT$$FOOTO$Sample PRGs.|#|Libraries$ENDFOOT$
$BOX$$FONT2$$TOC3$Sample PRGs.$TOC3$$FONT1$

The sample PRGs are provided to give you an example of how to add Treeducer 
to your own programs.  You may use these in your applications, and supply 
them in source format to your clients.

$CONDFF10$$FOOTE$Introduction|#|PCL Functions$ENDFOOT$$FOOTO$PCL Functions|#|Libraries$ENDFOOT$
$BOX$$FONT2$$TOC3$PCL Functions$TOC3$$FONT1$

The PCL Functions to print boxes and create macros and barcodes are 
supplied in source format to registered users.  You may not redistribute 
them in source format, but you may distribute the original or modified 
versions in FXP format.

$CONDFF10$$CONDFF20$

$FONT5$^bSection: $TOC2$Windows Notes$TOC2$^b$FONT1$


$FOOTE$Introduction|#|Printing to ASCII file$ENDFOOT$$FOOTO$Printing to ASCII file|#|Windows Notes$ENDFOOT$
$BOX$$FONT2$$TOC3$Printing to ASCII file$TOC3$$FONT1$

Using Treeducer style output with the Foxpro for Windows report writer is 
not terribly convenient.  Microsoft in its infinite wisdom decided that 
Windows programs would never need to create plain ASCII text versions of 
reports.

To create an ASCII report, you have a few choices.  First, you can force 
the user to include the Generic/Text only driver in their Windows setup.  
This will strip away most, but not all of the special formatting codes.  
Bold characters will be implemented by double striking the characters.  
This is not recommended.

Another way to create an ASCII file requires you to own the Foxpro DOS 
package, to create the report form using Foxpro Dos, and to NOT TRANSPORT 
it to the Windows environment, but just copy it.  This is OK as long as you 
own FoxDos.

Or, you can forget the report writer and just code everything using the old 
?? output.  This is probably not a terribly popular option among developers 
either.

There is usually a question about this once a week on FOXFORUM, and it has 
been suggested as an enhancement to Microsoft.  We will have to wait and 
see if it ever gets done.  In the meantime, using the DOS report forms in 
FoxWin seems to be the only semi-practical option.

$CONDFF10$$CONDFF20$

$FONT5$^bSection: $TOC2$Tech Support$TOC2$^b$FONT1$


$FOOTE$Introduction|#|Compuserve$ENDFOOT$$FOOTO$Compuserve|#|Tech Support$ENDFOOT$
$BOX$$FONT2$$TOC3$Compuserve$TOC3$$FONT1$

Compuserve is the preferred method of support at this time.  You can send 
Steve Tyrakowski Email at 73766,1224.  I log onto Compuserve usually 
several times a day, and should be able to get a fairly quick response back 
to you.

$CONDFF10$$FOOTE$Introduction|#|Telephone$ENDFOOT$$FOOTO$Telephone|#|Tech Support$ENDFOOT$
$BOX$$FONT2$$TOC3$Telephone$TOC3$$FONT1$

Telephone support should be a last resort.  Please try to find an answer to 
your question in the documentation before calling.  Instead of calling, 
please use Compuserve or Fax to send us your question if possible.

Our office is normally open Monday thru Friday from 8:30 AM to 4:00 PM 
Central time.  Please leave a message with the secretary if we are out of 
the office when you happen to call.

$CONDFF10$$FOOTE$Introduction|#|Fax$ENDFOOT$$FOOTO$Fax|#|Tech Support$ENDFOOT$
$BOX$$FONT2$$TOC3$Fax$TOC3$$FONT1$

If you don't have Compuserve access, Fax is the next preferred method of 
obtaining support.  Our Fax number is 708-422-3877.  Please address the 
message to SCT Associates, Tech Support.  Try to be concise, and keep the 
number of pages to a minimum.  Be sure to include a voice and Fax number 
where you can be reached, and what the best time to reach you is.  Any 
return calls will be made during our regular business hours.

$CONDFF10$$MIDDLE$$FONT5$^bChapter: $TOC1$Functions$TOC1$^b$FONT1$

$CONDFF20$

$FONT5$^bSection: $TOC2$Treeducer Options$TOC2$^b$FONT1$


$FOOTE$Functions|#|SET LIBRARY TO FOXTDC$ENDFOOT$$FOOTO$SET LIBRARY TO FOXTDC|#|Treeducer Options$ENDFOOT$
$BOX$$FONT2$$TOC3$SET LIBRARY TO FOXTDC$TOC3$$FONT1$

All these Treeducer functions are contained in the FOXTDC.PLB library for 
DOS and the FOXTDC.FLL library for Windows.  Before you can run any of 
these functions, you need to load the library with the following command:

SET LIBRARY TO FOXTDC

Note that if the FOXTDC library is not in the current direction, you may 
need to specify the full path to it.

$CONDFF10$$FOOTE$Functions|#|SendTD()$ENDFOOT$$FOOTO$SendTD()|#|Treeducer Options$ENDFOOT$
$BOX$$FONT2$$TOC3$SendTD()      Start Treeducer Printing$TOC3$$FONT1$

^bSyntax:^b
	SendTD(cFilename)

^bReturns:^b
	<nError> - return value from td_seterr 

^bDescription:^b

This function calls the Treeducer printing capability of the library.  The 
only parameter sent to the function is the filename.  All other parameters 
are set by the various TD_???? functions.

$CONDFF10$$FOOTE$Functions|#|TD_CopyCnt()$ENDFOOT$$FOOTO$TD_CopyCnt()|#|Treeducer Options$ENDFOOT$
$BOX$$FONT2$$TOC3$TD_CopyCnt()  Set Number of Copies$TOC3$$FONT1$

^bSyntax:^b
	TD_CopyCnt([nCopies])

^bReturns:^b
	<nCopies> - last value

^bDescription:^b

This function sets the number of UNCOLLATED copies that the printer will 
make.  Note that this simply sets the printer's built-in number of copies 
option.  It will save some time because the printer does not have to be 
resent tha data for each copy, however you will manually have to sort out 
the copies.

$CONDFF10$$FOOTE$Functions|#|TD_Device()$ENDFOOT$$FOOTO$TD_Device()|#|Treeducer Options$ENDFOOT$
$BOX$$FONT2$$TOC3$TD_Device()   Set the output device$TOC3$$FONT1$

^bSyntax:^b
	TD_Device([nPort])

^bReturns:^b
	<nPort> - last value

^bDescription:^b

This function sets the output device that will be used to print the 
treeducer output.  You may print to PRN or LPT1-3 directly which we 
recommend because it is the fastest output.  You may also direct your 
output to the current Foxpro  printer setting (This corresponds with 
?/??/??? output which is controlled by SET PRINT ON, and SET CONSOLE OFF).

The only reason that we would recommend using the Foxpro print device is in 
order to print to COM1 or COM2.

The options for nPort are:

	0  PRN device
	1  LPT1 device
	2  LPT2 device
	3  LPT3 device
	16 Foxpro print device

If you are going to use nPort=16, then be sure that you issue the following 
commands in your code:

	SET PRINTER TO <device>
	SET PRINT ON
	SET CONSOLE OFF


$CONDFF10$$FOOTE$Functions|#|TD_Directn()$ENDFOOT$$FOOTO$TD_Directn()|#|Treeducer Options$ENDFOOT$
$BOX$$FONT2$$TOC3$TD_Directn()  Set Print Direction$TOC3$$FONT1$

^bSyntax:^b
	TD_Directn([nDirection])

^bReturns:^b
	<nDirection> - last value

^bDescription:^b

This function describes the print direction when both horizontal and 
vertical page counts are greater than 1.  The default is to print ACROSS as 
the primary direction.

The available options for nDirection are:

	0 Print ACROSS, then DOWN
	1 Print DOWN, then ACROSS



^bSee Also:^b
TD_Orient()                                       

$CONDFF10$$FOOTE$Functions|#|TD_Display()$ENDFOOT$$FOOTO$TD_Display()|#|Treeducer Options$ENDFOOT$
$BOX$$FONT2$$TOC3$TD_Display()  Set your own Display Function$TOC3$$FONT1$

^bSyntax:^b
	TD_Display([cDispFunc])

^bReturns:^b
	<cDispFunc> - last value

^bDescription:^b

This function is used to specify the name of YOUR Foxpro UDF that will be 
used to display status information while Treeducer is printing your file.  
By default, Treeducer has a built-in status display, but you may replace 
that display with your own, or remove a display entirely.

You should specify the name of the function to be called WITHOUT parens.  
When Treeducer calls your function, it will pass it several pieces of 
information that will aid you in determining what is happening.  Your UDF 
should have the following PARAMETERS statement:

	PARAMETERS nPage, nCol, nPct, nStat

The parameters passed to your function have the following meaning:

	nPage -	This is the PHYSICAL page number being printed.  Each side of 
the paper is considered a new physical page.
	
	nCol  -	This is the logical page within the current physical page that 
is being printed.  For example, if the currnt report is going to a normal 
2-up style printout, nCol will be either 1 or 2.  If the printout is using  
8 horizontal and 6 vertical pages, then nCol will go from 1 to 48 as it 
fills in the 48 logical pages on the sheet.

	nPct  -	This is the percent of the input file that has been read into 
the buffer.  It can be used to display a thermometer or a percent of 
completion number.

	nStat -	This is a status code that describes the current Treeducer 
status.  Note that it is useful to be able to let the user know when 
Treeducer is printing or skipping the current page.  Also, when the 
minifont is selected, it can take a few seconds to download it to the 
printer, so you may want to display that message to the user.  The 
following statuses have been defined for nStat:

	0 - Error
	1 - Start
	2 - Printing
	3 - Skipping
	4 - Loading Soft Font
99    - Finished

Example:
				
The following is an example of a simple UDF that you might use to display a 
status screen:

PROCEDURE PrintIt
  =TD_Display("MyDisplay")
  =SendTD("tempfile.prn")
RETURN

FUNCTION MyDisplay
PARAMETERS nPage, nCol, nPct, nStat

  IF nStat == 0
    DEFINE WINDOW TreeStat ...etc.
    ACTIVATE WINDOW TreeStat
    @ 1, 4 SAY "Page        Column             Percent"
  ENDIF
	
  @ 1, 10 SAY nPage PICTURE "999" IN WINDOW TreeStat
  @ 1, 23 SAY nCol  PICTURE "99"  IN WINDOW TreeStat
  @ 1, 43 SAY nPct  PICTURE "999" IN WINDOW TreeStat
	
DO CASE
	CASE nStat == 1
	  @ 2, 4 SAY "Printing . . .         " IN WINDOW TreeStat
			
	CASE nStat == 2
	  @ 2, 4 SAY "Skipping . . .         " IN WINDOW TreeStat
	   		
	CASE nStat == 3
	  @ 2, 4 SAY "Loading Soft Font . . ." IN WINDOW TreeStat
	   		
	CASE nStat == 99		
	  WAIT WINDOW "Printing is complete"
	  DEACTIVATE WINDOW TreeStat
ENDCASE
	
RETURN .T.



$CONDFF10$$FOOTE$Functions|#|TD_Duplex()$ENDFOOT$$FOOTO$TD_Duplex()|#|Treeducer Options$ENDFOOT$
$BOX$$FONT2$$TOC3$TD_Duplex()   Set Double Sided Options$TOC3$$FONT1$

^bSyntax:^b
	TD_Duplex([nDuplex])

^bReturns:^b
	<nDuplex> - last value

^bDescription:^b

This function will set the duplex printing option of Treeducer.  By 
default, Treeducer assumes that you are printing single-sided.  If you have 
a duplex printer such as the Laserjet IID or IIID, you can automatically 
print double-sided across the long edge or the short edge.  What this 
refers to is the side of the paper that you will bind (or hole punch) the 
paper.  If you will put it into a standard 8.5 x 11 binder, you'll most 
likely be punching holes on the LONG edge of the paper, so you should 
select duplex long edge.

Even if you have a standard laser printer that does not automatically 
handle double sided printing, you can still get double sided output with a 
little manual intervention.  Treeducer will let you print out all the FRONT 
pages seperately from all the BACK pages.  This way, you can prompt the 
user to re-insert the paper after printing the fronts, and then print all 
the backs to give them double sided output.  

Note that this takes some practice to determine which way to reload the 
paper, so please be sure to give your clients adequate instruction.  Also, 
when printing the second side, there is a greater tendency to have the 
printer jam because the paper is usually curled from printing the first 
side.

The values available for nDuplex are:

	0 Single Sided (default)
	1 Duplex Long Edge
	2 Duplex Short Edge
	3 Front Side Only
	4 Back Side Only
	


^bSee Also:^b
Overview                                          

$CONDFF10$$FOOTE$Functions|#|TD_Escape()$ENDFOOT$$FOOTO$TD_Escape()|#|Treeducer Options$ENDFOOT$
$BOX$$FONT2$$TOC3$TD_Escape()   Output escape codes$TOC3$$FONT1$

^bSyntax:^b
	TD_Escape([lEscape])

^bReturns:^b
	<lEscape> - last value

^bDescription:^b

This function allows you to tell Treeducer to send escape codes it finds in 
the file to the printer or to replace it with a character seventeen.  The 
defualt is not to send the escape codes to the printer.



$CONDFF10$$FOOTE$Functions|#|TD_Font()$ENDFOOT$$FOOTO$TD_Font()|#|Treeducer Options$ENDFOOT$
$BOX$$FONT2$$TOC3$TD_Font()     Set the printout font$TOC3$$FONT1$

^bSyntax:^b
	TD_Font([nFont])

^bReturns:^b
	<nFont> - last value

^bDescription:^b

This function tells Treeducer which font to use when printing the report.  
The default is to use the standard 16.66 condensed font built in to the 
printer.  We have adjusted the horizontal character spacing to condense the 
font a little bit further and get a few more characters per line.

We have also developed our own soft font that is built into the library and 
gets downloaded to the printer when used.  This soft "mini" font will allow 
you to print 2 pages of 132 column text side-by-side.  We suggest printing 
88 lines per page when using this font because it is also not as tall as 
the normal condensed font.  

Isn't that minifont awfully tiny and hard to read if it will fit that many 
characters per page? Well, yes, the font is fairly small, and you would not 
want to work with a report like that for any extended period of time.  What 
we've found is that there are lots of reports that get printed for archive 
purposes, or for occassional reference if the computer happens to be down.  
This is ideal for these reports because of how much it reduces the storage 
space needs of all that paper.

The values for nFont are:
	0 Use the condensed font
	1 Use the mini soft font
	
	

$CONDFF10$$FOOTE$Functions|#|TD_Frame()$ENDFOOT$$FOOTO$TD_Frame()|#|Treeducer Options$ENDFOOT$
$BOX$$FONT2$$TOC3$TD_Frame()    Set Border Style$TOC3$$FONT1$

^bSyntax:^b
	TD_Frame([nStyle])

^bReturns:^b
	<nStyle> - last value

^bDescription:^b

This function sets the frame/border style that will be used by the 
Treeducer printing process.  There are several types of frames that may be 
selected:

	0 No Frame
	1 Box Frame (default)
	2 T bar Frame
	4 I bar Frame



$CONDFF10$$FOOTE$Functions|#|TD_GrnBar()$ENDFOOT$$FOOTO$TD_GrnBar()|#|Treeducer Options$ENDFOOT$
$BOX$$FONT2$$TOC3$TD_GrnBar()   Set Greenbar Shading$TOC3$$FONT1$

^bSyntax:^b
	TD_GrnBar([nShadeStyle 
		[,nShadeSize 
		[,nShadePct  ] ] ] )

^bReturns:^b
	<nShadeStyle> - last value

^bDescription:^b

This function turns on the simulated greenbar shading.  This is designed to 
appear similar to the traditional computer paper that is shaded for 
alternate groups of nShadesize lines.  By shading groups of lines, it is 
easier to match up data on the left side of the paper with info on the 
right side.  It is pretty easy to see that the data you want is in the top 
line of shaded area at left, so you look at the top line of the shaded area 
at the right.

The values for nShadeStyle are:

	1 - Shading
	2 - Solid lines
	4 - Dashed lines

You can have a combination of solid or dashed lines with shading by adding 
the two values.  Solid and dashed lines can't be mixed because the solid 
lines will overwrite the dashed lines.

Note that when using the mini soft font, the characters are not very bold, 
and when you print a shading pattern on top of them, they can get difficult 
to read.  For this reason, we provided the horizontal line options so that 
you can get similar benefits without actually shading the area.  The dashed 
lines are a nice alternative to a solid line which  can get a little 
distracting.	

The nShadeSize option lets you specify the number of lines to include in 
each grouping that is shaded or lined.  The default is 3, but you may 
specify any number greater than 1.

The nShadePct option lets you specify the shading percentage used when you 
shade the lines.  This is set to a default of 10%.

$CONDFF10$$FOOTE$Functions|#|TD_HPages()$ENDFOOT$$FOOTO$TD_HPages()|#|Treeducer Options$ENDFOOT$
$BOX$$FONT2$$TOC3$TD_HPages()   Set Horizontal Page Count$TOC3$$FONT1$

^bSyntax:^b
	TD_HPages([nCount])

^bReturns:^b
	<nCount> - last value

^bDescription:^b

This function will set how many logical pages will be fit horizontally 
across the physical page.  The default is to "autosize" the number of pages 
horizontally by looking ahead at the first 10,000 bytes of the input file 
and finding the maximum line size.  You may force the number of horizontal 
pages by specifying the count.

Available options for nCount:

	0 Autosize (default)
	1-? Force the number of columns

The maximum number of columns you can specify depends on the size of the 
paper you are using, the font you selected and line numbering style.  If 
the number of columns specified doesn't leave enough room to print five 
character columns then Treeducer will ajust the number of page columns so 
there is.



^bSee Also:^b
TD_VPages(), TD_Directn()                         

$CONDFF10$$FOOTE$Functions|#|TD_LPP()$ENDFOOT$$FOOTO$TD_LPP()|#|Treeducer Options$ENDFOOT$
$BOX$$FONT2$$TOC3$TD_LPP()      Set Lines per Page$TOC3$$FONT1$

^bSyntax:^b
	TD_LPP([nLines])

^bReturns:^b
	<nLines> - last value

^bDescription:^b

This function is used to set the number of lines per logical page printed 
by Treeducer.  The default value is 66 lines per page when you use the 
TD_Set() method of setting parameters.

You may set the value of this parameter to 0 and Treeducer will "autosize" 
the page by determining the physical height of the logical page, and then 
by using the "optimal height" of the font being used will determine how 
many lines will fit.  This is normally not useful when printing typical 
reports from a database system.  You may find it useful when printing large 
text files that are not formatted already to a particular number of lines 
per page.	

$CONDFF10$$FOOTE$Functions|#|TD_Number()$ENDFOOT$$FOOTO$TD_Number()|#|Treeducer Options$ENDFOOT$
$BOX$$FONT2$$TOC3$TD_Number()   Set Line Numbering Style$TOC3$$FONT1$

^bSyntax:^b 
	TD_Number([nStyle])

^bReturns:^b
	<nStyle> - last value

^bDescription:^b

This function sets the line counting style to be used by Treeducer.  The 
default is not to print any line numbers, which is most appropriate for 
normal database system reports.  If you are printing out source code or 
some legal documents, you may have different line numbering needs.

There are two components to the line numbering option, first is the rule 
for how to number the lines, and second is how to display the numbers on 
the printout.  The values for each component are listed below:

	0 		No counting (default)
	16 		Turns Counting on
	
	Add		Counting Rules
	
	0		Count lines for whole file
	1		Reset Count at each page
	2		Count Wrapped lines as new number
			by default, wrapped lines are just
			a continuation of the previous one
			and do not get a number
			
	Add		Display Rules
	
	4		Shade the line number
	8		Place vertical line to the right
			of the line number

Example:

To print out line numbers filewide with shading and a vertical line to the 
right of the number:
	TD_Number(16+4+8)
	
To print out line numbers that start at 1 on each page with a vertical line 
to the right of them:
	TD_Number(16+1+8)	

$CONDFF10$$FOOTE$Functions|#|TD_Orient()$ENDFOOT$$FOOTO$TD_Orient()|#|Treeducer Options$ENDFOOT$
$BOX$$FONT2$$TOC3$TD_Orient()   Set Portrait/Landscape$TOC3$$FONT1$

^bSyntax:^b
	TD_Orient([nOrientation])

^bReturns:^b
	<nOrientation> - last value

^bDescription:^b

This function sets the printer orientation of the Treeducer output.  The 
default is to use Landscape orientation.  The values to send for the 
nOrientation parameter are:

	0 Portrait
	1 Landscape
		

^bSee Also:^b
TD_Directn()                                      

$CONDFF10$$FOOTE$Functions|#|TD_Paper()$ENDFOOT$$FOOTO$TD_Paper()|#|Treeducer Options$ENDFOOT$
$BOX$$FONT2$$TOC3$TD_Paper()    Set the Paper Size$TOC3$$FONT1$

^bSyntax:^b
	TD_Paper([nPaper])	

^bReturns:^b 
	<nPaper> - last value

^bDescription:^b	

This function will set the paper size used by the   SendTD() function.  The 
paper sizes that are defined to the program are:

	Papers:
		0 Letter (8 1/2 x 11 in.) (default)
		1 Legal (8 1/2 x 14 in.)
		2 Executive (7 1/4 x 10 1/2 in.)
		3 A4 (210mm x 297mm)
	
	Envelopes:
		4 Com10 (4 1/8 x 9 1/2 in.)
		5 Monarc (3 7/8 x 7 1/2 in.)
		6 C5 (162mm x 229mm)
		7 DL (110mm x 220mm)

The paper size setting tells Treeducer the horizontal and vertical 
dimensions of the paper so that it can adjust its printable areas 
accordingly.  Although printing with Treeducer to envelopes doesn't seem 
likely, we've included them here in case anyone decides to print to special 
forms that use those same dimensions.	

$CONDFF10$$FOOTE$Functions|#|TD_Range()$ENDFOOT$$FOOTO$TD_Range()|#|Treeducer Options$ENDFOOT$
$BOX$$FONT2$$TOC3$TD_Range()    Set Page Range to Print$TOC3$$FONT1$

^bSyntax:^b
	TD_Range(nStart, nEnd)

^bReturns:^b
	.T.

^bDescription:^b

This function allows you to limit which pages will print in the output.  
The default is to print all the pages in the report. (note that the 
seperate printing of fronts and backs is controlled by the TD_Duplex() 
function and also limits the printing in addition to the range setting)

The nStart page number tells the first page to be printed and the nEnd 
parameter tells the last page.  The default for nStart and nEnd is zero 
which will print from the beginning to the end of the report.  If nEnd is 
less than nStart, nEnd will be set equal to nStart.

See Also: TD_Duplex()	

$CONDFF10$$FOOTE$Functions|#|TD_Set()$ENDFOOT$$FOOTO$TD_Set()|#|Treeducer Options$ENDFOOT$
$BOX$$FONT2$$TOC3$TD_Set()      Initialize Parameters$TOC3$$FONT1$

^bSyntax:^b
	TD_Set()

^bReturns:^b
	.T.	

^bDescription:^b

This function initializes the Parameters used by the Treeducer Library to 
their default values.  It should be called to default the parameters back 
to thier original settings.		

See Also: Send_TD()

$CONDFF10$$FOOTE$Functions|#|TD_SetErr()$ENDFOOT$$FOOTO$TD_SetErr()|#|Treeducer Options$ENDFOOT$
$BOX$$FONT2$$TOC3$TD_SetErr()   Set/Get current error$TOC3$$FONT1$

^bSyntax:^b
	TD_SetErr([nError])

^bReturns:^b
	<nError> - last value

^bDescription:^b

	Treeducer error codes:
		0  - no error
		1  - file does not exist
		2  - could not open file
		3  - could not open output
		4  - could not allocate memory for columns
		5  - error writing to output
		6  - error reading input
		7  - user abort
		16 - Could not allocate buffer for foxpro output

You can set an error from 1 to 254 that will abort treeducer.  You can only 
set an error form within a user defined title or display function.  This is 
useful to setup your own way to abort treeducer.


$CONDFF10$$FOOTE$Functions|#|TD_Tabs()$ENDFOOT$$FOOTO$TD_Tabs()|#|Treeducer Options$ENDFOOT$
$BOX$$FONT2$$TOC3$TD_Tabs()     Set Tab Size$TOC3$$FONT1$

^bSyntax:^b	
	TD_Tabs([nTabsize])

^bReturns:^b
	<nTabsize> - last value

^bDescription:^b

This function will allow you to set the size that tabs will be expanded to 
when printing out the report.  The default is to assume that tabs are set 
to 8, but you may set it to any value between 0 and 16.	

$CONDFF10$$FOOTE$Functions|#|TD_Title()$ENDFOOT$$FOOTO$TD_Title()|#|Treeducer Options$ENDFOOT$
$BOX$$FONT2$$TOC3$TD_Title()    Set Title Line options$TOC3$$FONT1$

^bSyntax:^b
	TD_Title([cnTitleFunc])

^bReturns:^b
	<cnTitle> - last value

^bDescription:^b

This function will allow you to print your own title lines on both the top 
and bottom margin of the paper.  The default is to print the filename and 
the date and time printed, as well as the physical page number.  

To control the display, you may set the title yourself by supplying the 
name of a function that Treeducer should call when it needs to print the 
title line.  Your function will be passed three parameters, lTop, nPage and 
nWidth.  IF lTop is true the string you return will be printed at the top 
of the page, if it is false is will be printed at the bottom of the page.  
The nPage parameter is the physical page number, the function will be 
called twice for each physical page number.  The nWidth parameter is how 
many characters wide the paper is.

Instead of defining your own title function, you may pass the following 
numeric parameters to use some pre-built title options:

	0	No titles will be printed (default)
	1	Print file name, date, time, page number on bottom of page
	2	Print file name, date, time, page number on top of page
	3	Print on top on even pages, and on bottom on odd pages

Example:

PROCEDURE Example
 =TD_Title("MyTitle")
 =SendTD()
RETURN

* This function prints odd pages on bottom
* and even pages on top
FUNCTION MyTitle
PARAMETERS lTop, nPage, nWidth
PRIVATE cReturn
DO CASE
	CASE lTop .AND. nPage % 2 == 1
	  cReturn = ""
	CASE (.NOT. lTop) .AND. nPage % 2 == 0
	  cReturn = ""
	OTHERWISE
	  cReturn=Space(80)+"Page: "+PadL(nPage,4)
ENDCASE
RETURN cReturn		
  

$CONDFF10$$FOOTE$Functions|#|TD_Tray()$ENDFOOT$$FOOTO$TD_Tray()|#|Treeducer Options$ENDFOOT$
$BOX$$FONT2$$TOC3$TD_Tray()     Set the Source Paper Tray$TOC3$$FONT1$

^bSyntax:^b
	TD_Tray([nTray])

^bReturns:^b
	<nTray> - last value

^bDescription:^b

This function will set which paper source should be used when printing.  In 
most cases, there will be no need to tell the printer to use a special 
tray, normally the default tray will have the regular paper you need.  The 
available options for nTray are:

	0 Printer's Default Tray (default)
	1 Force Upper Tray
	2 Force Lower Tray

$CONDFF10$$FOOTE$Functions|#|TD_VPages()$ENDFOOT$$FOOTO$TD_VPages()|#|Treeducer Options$ENDFOOT$
$BOX$$FONT2$$TOC3$TD_VPages()   Set Vertical Page Count$TOC3$$FONT1$

^bSyntax:^b
	TD_VPages(<nCount>)

^bReturns:^b
	<nCount> - last value

^bDescription:^b

This function will set the number of logical pages that will be set 
vertically on the physical page.  The default is 1, and normally will not 
need to be changed.  The maximum vertical columns is dependant on the paper 
size that you are using.  If the number of columns you specify does not 
leave enough room to print five rows in each column, Treeducer will ajust 
the number so that it does.

The times when this option may be useful will be when you want to print 
screen shots that are 80x25 and each one is defined in a seperate page.  In 
these cases, you may want to fit several pages vertically, especially if 
you happen to choose portrait orientation.



^bSee Also:^b
TD_HPages(), TD_Directn()                         

$CONDFF10$$FOOTE$Functions|#|TD_WSpace()$ENDFOOT$$FOOTO$TD_WSpace()|#|Treeducer Options$ENDFOOT$
$BOX$$FONT2$$TOC3$TD_WSpace()   Set printing of whitespace$TOC3$$FONT1$

^bSyntax:^b
	TD_WSpace([nWSpace])

^bReturns:^b
	<nWSpace> - last value

^bDescription:^b

This function will disable - 0 or enable - 1 printing of whitespace at the 
end of a file.  Whitespace consists of spaces, linefeeds, carriagereturns, 
formfeeds, tabs, primary and secondary font characters.


$CONDFF10$$FOOTE$Functions|#|TD_Wrap()$ENDFOOT$$FOOTO$TD_Wrap()|#|Treeducer Options$ENDFOOT$
$BOX$$FONT2$$TOC3$TD_Wrap()     Set Wrapping/Truncation$TOC3$$FONT1$

^bSyntax:^b
	TD_Wrap([nWrap])

^bReturns:^b
	<nWrap> - last value

^bDescription:^b

This function allows you to tell Treeducer how to handle lines that are 
longer than the logical page that it is being printed to.  The default is 
to truncate the excess that will not fit.  You may also tell Treeducer to 
wrap those long lines and continue them on the following line.

The available wrapping options are:

	0 Truncate long lines
	1 Wrap at width of current logical page

Normally, you'd not care much about wrapping in your standard database 
applications.  You will most likely handle the page width of your own 
reports so that they will not need to wrap.  The wrapping will be used if 
you print out source code using Treeducer.

One advantage of the truncation feature is that if the user only cares 
about the data in the first few columns of the report, they can tell 
Treeducer to use more pages horizontally and truncate what doesn't fit.  
This way they can cut down the existing reports even further at runtime 
without any actual changes to the report code or form.

$CONDFF10$$CONDFF20$

$FONT5$^bSection: $TOC2$PCL functions$TOC2$^b$FONT1$


$FOOTE$Functions|#|PCL Functions$ENDFOOT$$FOOTO$PCL Functions|#|PCL functions$ENDFOOT$
$BOX$$FONT2$$TOC3$PCL Functions$TOC3$$FONT1$

The PCL Functions are included with the registered version of the library.  
The full Foxpro source code for these functions is included with the full 
product.

All of these functions return a character string, and it is your 
responsibility to send it to the printer with the ? output, and @ SAY, or 
via a report form.

$CONDFF10$$FOOTE$Functions|#|Barcode()$ENDFOOT$$FOOTO$Barcode()|#|PCL functions$ENDFOOT$
$BOX$$FONT2$$TOC3$Barcode()     Print 3 of 9 barcode$TOC3$$FONT1$

^bSyntax:^b
   BarCode(<cString>, [<nHeight>], [<nNarrow>],[<nWide>],[<lVert>])

Formal Arguments:
   <cString>     string to print as barcode
   <nHeight>     Bar Code Height in dots (300 per inch) default = 120
   <nNarrow>     Width of narrow bar in dots (300/in) default = 4
   <nWide>       Width of wide bar in dots (300/in) default = 10
   <lVertical>   Print the barcode verticaly (default = .f.)

Note that although the width of the narrow and wide bars may be changed, 
you should test the bar codes thoroughly if you change the widths.  The 3 
of 9 spec is fairly tolerant, but many scanners are much fussier.  You 
should try to test the printed codes with the actual scanners that will be 
used to read them.

^bReturns:^b
   <cCode> Character string containing printer escape codes

^bDescription:^b
This function allows you to print a 3 of 9 barcode in the current 
orientation at the current printer position.

The bars are drawn using the PCL box drawing functions.  This routine 
pushes the current position before printing the bar code, then pops it back 
afterwards so that the print cursor is at the same spot that it started at.

The current printer position will be the upper left corner of the bar code.

The character set supported by this 3 of 9 implementation includes:
   numbers     0-9
   characters  A-Z (upper only)
   marks   - . * $ / + %
   and space Chr(32)



^bSee Also:^b
LJ_GoTo()                                         

$CONDFF10$$FOOTE$Functions|#|LJ_GoTo()$ENDFOOT$$FOOTO$LJ_GoTo()|#|PCL functions$ENDFOOT$
$BOX$$FONT2$$TOC3$LJ_GoTo()     Position PCL cursor$TOC3$$FONT1$

^bSyntax:^b
   LJ_GoTo(<xRow>, <xCol>) => cEscCodes

Formal Arguments:
   <xRow> row to go to (in dots - 300 per inch)
   <xCol> col to go to (in dots - 300 per inch)

Note that these parameters may be number or character.  If they are 
character, then they are used as-is where the row or col gets specified.  
This allows for relative positioning by using the + or - in front of the 
number.

^bReturns:^b
   Character string containing printer escape codes

^bDescription:^b
This function allows you to position the PCL cursor in the LaserJet to the 
Row/Column dot position based on a 300 dot per inch grid.

Positioning may be absolute or relative.



^bSee Also:^b
LJ_VLine(),LJ_HLine(),LJ_Rec(),LJ_Run(),LJ_Box()  

$CONDFF10$$FOOTE$Functions|#|LJ_Box()$ENDFOOT$$FOOTO$LJ_Box()|#|PCL functions$ENDFOOT$
$BOX$$FONT2$$TOC3$LJ_Box()      Draw and shade a box$TOC3$$FONT1$

^bSyntax:^b
   LJ_Box(<xRow>, <xCol>, <nHeigth>, <nWidth>, [<nBorder>];
          , [<nShade>], [<nPattern>])   => cEscCodes

Formal Arguments:
   <xRow>      row that is passed to LJ_GoTo

   <xCol>      col that is passed to LJ_GoTo

Note that row and col are both optional, in which case they will use the 
current location.  See the LJ_GoTo function for more info.

   <nHeigth>   Heigth of box in dots (300/inch)

   <nWidth>    Width of box in dots (300/inch)

   <nBorder>   Thickness of lines that make up box in dots(300/inch).
               If not specified, Rule mode will be used which results       
         in a black box.

   <nShade>    0 - 100 percent of shading of box.  Note that there
               are only nine distinct levels available based on the         
       following ranges of percentages:

                  0       No shading.
                  1  - 2
                  3  -10
                  11 -20
                  21 -35
                  36 -55
                  56 -80
                  81 -99
                  100     All black.

   <nPattern>  Pattern to fill box with.  There are 6 defined patterns
               available as follows:

                  1 - Horizontal lines
                  2 - Vertical lines
                  3 - Diagonal lines lower left to upper right
                  4 - Diagonal lines upper left to lower right
                  5 - Pattern #1 and Patter #2 combined
                  6 - Pattern #3 and Patter #4 combined

^bReturns:^b
   Character field containing Escape codes for box draw.

^bDescription:^b
This function allows you to draw shaded or pattern boxes using the PCL 
commands built-in to the LaserJet.  All dimensions are to be expressed in 
Dots which represent 1/300th of an inch.

If a row and column are passed to the function, then the PCL cursor will be 
positioned to that location before drawing the box.  The location specified 
will be the upper left corner of the box. The current cursor location will 
be saved before drawing the box, and restored afterward.


^bExamples:^b
   ?? LJ_Box(300,600,150,1200)
*        draws a black box .5 inches tall by 4 inches wide
*        starting 1 inch from top and two inches from left.

   ?? LJ_Box(300,600,150,1200,3,20)
*        draws a box .5 inches tall by 4 inches wide
*        starting 1 inch from top and two inches from left.
*        the box has a border that is 3 dots thick (1/100th inch)
*        and is filled in with a 20% grey-scale shading.



^bSee Also:^b
LJ_GoTo(), LJ_HLine(), LJ_VLine()                 

$CONDFF10$$FOOTE$Functions|#|LJ_Rec()$ENDFOOT$$FOOTO$LJ_Rec()|#|PCL functions$ENDFOOT$
$BOX$$FONT2$$TOC3$LJ_Rec()      Record a Macro$TOC3$$FONT1$

^bSyntax:^b
   LJ_Rec( nMacro ) => cEscCodes

Parameters:
<nMacro> number of printer macro to start recording leave it NIL to         
 stop recording.  Note that there may only be 32 macros stored          in 
the printer's memory at one time.  The number itself can          be larger 
than 32.

^bReturns:^b
Character string containing printer escape codes to to define macro

^bDescription:^b
This function will control the starting and stopping of the LaserJet PCL 
record mode. If a number is passed as a parameter, that will be the macro 
ID number to start recording.  If no parameter is passed, it will signal 
the end of macro recording.

Note that there is no error checking to see if you are currently recording 
a macro.



^bSee Also:^b
LJ_Del(), LJ_Run()                                

$CONDFF10$$FOOTE$Functions|#|LJ_Run()$ENDFOOT$$FOOTO$LJ_Run()|#|PCL functions$ENDFOOT$
$BOX$$FONT2$$TOC3$LJ_Run()      Run a Macro$TOC3$$FONT1$

^bSyntax:^b
   LJ_Run( nMacro) => cEscCodes

Parameters:
   <nMacro> macro to run

^bReturns:^b
   Character string containing printer escape codes to run a macro

^bDescription:^b
This function will run the macro number specified from the Laser printer's 
memory.  It must have been recorded first using the LJ_Record function.

^bExamples:^b
   ?? LJ_Run(99)     && runs macro 99 from printer memory



^bSee Also:^b
LJ_Rec(), LJ_Del()                                

$CONDFF10$$FOOTE$Functions|#|LJ_Del()$ENDFOOT$$FOOTO$LJ_Del()|#|PCL functions$ENDFOOT$
$BOX$$FONT2$$TOC3$LJ_Del()      Delete a Macro$TOC3$$FONT1$

^bSyntax:^b
   LJ_Delete( nMacro ) => cEscCodes

Parameters:
   <nMacro> macro ID to be deleted from printer memory.

^bReturns:^b
   Character string containing printer escape codes to delete a macro

^bDescription:^b
This function returns the PCL character string to delete a specified macro 
from the printer's memory.

^bExamples:^b
   ?? LJ_Del(99)     && removes macro 99 from printer memory



^bSee Also:^b
LJ_Run(), LJ_Rec()                                

$CONDFF10$$FOOTE$Functions|#|LJ_VLine()$ENDFOOT$$FOOTO$LJ_VLine()|#|PCL functions$ENDFOOT$
$BOX$$FONT2$$TOC3$LJ_VLine()    Draw a vertical line$TOC3$$FONT1$

^bSyntax:^b
   LJ_VLine(<nLen>, <nThick>)  => cEscCodes

Formal Arguments:
   <nLen>     length of line
   <nThick> thickness of line

^bReturns:^b
   Character string containing printer escape codes

^bDescription:^b
Draws a Vertical line at the current cursor position on the page.  You may 
specify the thickness of the line and how long it is in Dots   (300 per 
inch)



^bSee Also:^b
LJ_HLine(), LJ_Box(), LJ_GoTo()                   

$CONDFF10$$FOOTE$Functions|#|LJ_HLine()$ENDFOOT$$FOOTO$LJ_HLine()|#|PCL functions$ENDFOOT$
$BOX$$FONT2$$TOC3$LJ_HLine()    Draw a horizontal line$TOC3$$FONT1$

^bSyntax:^b
   LJ_HLine(<nLen>, <nThick>)  => cEscCodes

Formal Arguments:
   <nLen>     length of line
   <nThick>   thickness of line

^bReturns:^b
   Character string containing printer escape codes
^bDescription:^b
Draws a Horizontal line at the current cursor position on the page.  You 
may specify the thickness of the line and how long it is in Dots (300 per 
inch)



^bSee Also:^b
LJ_VLine(), LJ_Box(), LJ_GoTo()                   

$CONDFF10$$FOOTE$Functions|#|LJ_GoRC()$ENDFOOT$$FOOTO$LJ_GoRC()|#|PCL functions$ENDFOOT$
$BOX$$FONT2$$TOC3$LJ_GoRC()     Position PCL cursor$TOC3$$FONT1$

^bSyntax:^b
   LJ_GoRC([<xRow>], [<xCol>]) => cEscCodes

Formal Arguments:
   [<xRow>] row to go
   [<xCol>] col to go

Note that these parameters may be number or character.  If they are 
character, then they are used as-is where the row or col gets specified.  
This allows for relative positioning by using the + or - in front of the 
number.

^bReturns:^b
   Character string containing printer escape codes

^bDescription:^b
This function allows you to position the PCL cursor in the LaserJet to the 
Row/Column position.

Positioning may be absolute or relative.



^bSee Also:^b
LJ_GoTo()                                         

$CONDFF10$$MIDDLE$$FONT5$^bChapter: $TOC1$Sample Code$TOC1$^b$FONT1$

$CONDFF20$

$FONT5$^bSection: $TOC2$Reporting$TOC2$^b$FONT1$


$FOOTE$Sample Code|#|SAMPLE.PRG$ENDFOOT$$FOOTO$SAMPLE.PRG|#|Reporting$ENDFOOT$
$BOX$$FONT2$$TOC3$SAMPLE.PRG    Top Menu for sample program$TOC3$$FONT1$

The SAMPLE.PRG program is a simple menu that lets you run the Statement 
form, the invoice form, and a simple report form using the Do_Frm() 
function to offer screen, printer, file, treeducer options.

$CONDFF10$$FOOTE$Sample Code|#|TREESET.PRG$ENDFOOT$$FOOTO$TREESET.PRG|#|Reporting$ENDFOOT$
$BOX$$FONT2$$TOC3$TREESET.PRG   Sample User Prompts$TOC3$$FONT1$

The TREESET.PRG sample program illustrates an example of how you might 
prompt the users for the various Treeducer printing options such as greybar 
shading and double sided printing.

Feel free to use the code as-is if you desire.  It is provided in source 
code form so that you can adapt the user interface to match the rest of 
your application.  We have tried to keep all user interface code separate 
from the library, since we feel that the user interface should be 
controlled by the developer, not the library provider.

$CONDFF10$$FOOTE$Sample Code|#|Do_Frm.PRG$ENDFOOT$$FOOTO$Do_Frm.PRG|#|Reporting$ENDFOOT$
$BOX$$FONT2$$TOC3$Do_Frm.PRG    Sample Report Form shell$TOC3$$FONT1$

The DOFORM.PRG is included to give you a simple way to direct your output 
to screen, printer, file or Treeducer.  Note that this assumes that your 
reports are being created as plain ASCII files.  If you are including 
special fonts in your reports, it will not be compatible with Treeducer 
style output.

^bSyntax:^b    = Do_Frm( cForm. cTitle, cFile, cSetup, cDone)
Parameters:
  cForm  - Name of the FRX file to run	                  Required
  cTitle - Title for report output window	              Required
  cFile  - Filename if print to file 	                  Required
  cSetup - UDF to call to Setup (i.e. to open DBFs)       Optional
  cDone  - UDF to call after running report to clean up	  Optional

Purpose:
   The purpose of this function is to allow a report to go to
   screen, printer, file, or Treeducer easily.


$CONDFF10$$CONDFF20$

$FONT5$^bSection: $TOC2$Forms Creation$TOC2$^b$FONT1$


$FOOTE$Sample Code|#|INVOICE.PRG$ENDFOOT$$FOOTO$INVOICE.PRG|#|Forms Creation$ENDFOOT$
$BOX$$FONT2$$TOC3$INVOICE.PRG   Sample Invoice Form$TOC3$$FONT1$

The sample INVOICE.PRG program illustrates how to design a custom form that 
could be used as an invoice.  In our custom apps, we like to recommend a 
double sided printer with 2 input trays.  We keep the second tray filled 
with letterhead paper, and we print out all our forms directly onto 
letterhead.

The invoice form illustrates several techniques:  

1. We use the laser printer's macro capability to "record" the commands 
that print the form itself.  This lets us call up the form with a very 
short escape sequence to "run" the macro.

2. We printed a bar code on the form to illustrate how this would  work.  
Just remember, in a real application, you'd probably not put the barcode 
into the "form", but rather in your application code that prints data onto 
the form.

3. We use the LJ_GoTo() function to do a lot of cursor positioning.   Note 
that at the end of the "macro", we position the PCL cursor at the top of 
the form so that it is ready for the application to start filling in the 
data as if it were using a preprinted form.

4. We select different fonts for printing the form, so that it gets a 
"pre-printed" look instead of using the same fonts that will be used to 
fill it in.  Note that we are typically using proportional fonts which are 
very difficult to accurately position.  We use a "Z" cartridge on our 
series II laserjets, but the Laser III and higher have suitable scalable 
fonts built-in.  These fonts are very similar, but are different enough to 
cause misaligned text between the old and newer printers when printed using 
@ SAY positioning.  To help the form print correctly, we use the LJ_GoTo() 
function to position each text label for printing.

$CONDFF10$$FOOTE$Sample Code|#|STM.PRG$ENDFOOT$$FOOTO$STM.PRG|#|Forms Creation$ENDFOOT$
$BOX$$FONT2$$TOC3$STM.PRG       Sample A/R Statement Form$TOC3$$FONT1$

The STM.PRG sample program illustrates another sample form that you might 
print directly on the laserjet nistead of using preprinted forms.  This 
form illustrates mostly the same features that were in the INVOICE.PRG 
sample.  This form utilizes several levels of shading to highlight how far 
past due each column is.

$CONDFF10$