
* 
* Purpose: Delete Laser Printer Macro
* Author: Kevin Maher/Steve Tyrakowski
* Copyright: 1993 SCT Associates, Inc.
* 
* Section:2. LaserJet
* Category:Laserjet Macros
*
* Syntax:
*          LJ_Delete( nMacro ) => cEscCodes
*
* Parameters:
*          <nMacro> macro ID to be deleted from printer memory.
*
* Returns:
*          Character string containing printer escape codes
*          to delete a macro
*
* Description:
*         This function returns the PCL character string to delete
*         a specified macro from the printer's memory.
*
* Examples:
*       ?? LJ_Del(99)     // removes macro 99 from printer memory
*
* See Also:
*         LJ_Rec() LJ_Run
*
* Revisions:
*
* 

FUNCTION LJ_Del
PARAMETERS nMacro
RETURN  "&f"+Alltrim(Str(nMacro))+"y8X"
