
********************************************************
* Purpose:Draw a horizontal line on a laser printer
* Category:Laserjet Functions
* Section:2. LaserJet
* Copyright: 1993 SCT Associates, Inc
* Author: Steve Tyrakowski/Kevin Maher
*
* Description:
*      Draws a Horizontal line at the current cursor position
*      on the page.  You may specify the thickness of the line
*      and how long it is in Dots (300 per inch)
*
* Syntax:
*      LJ_HLine(<nLen>, <nThick>)  => cEscCodes
*
* Formal Arguments:
*      <nLen>     length of line
*      <nThick>   thickness of line
*
* Returns:
*      Character string containing printer escape codes
*
* See Also:
*      LJ_VLine() LJ_GoTo() LJ_Rec() LJ_Run() LJ_Box()
********************************************************

FUNCTION LJ_HLine
PARAMETERS nLen, nThick
  if parameters() < 2
    nThick = 5
  endif
RETURN (LJ_Box(-1,-1,nThick,nLen+nThick))
